## pam-u2f 1.4.0

=== CMakeLists.txt ===
# Copyright (C) 2025 Yubico AB - See COPYING

cmake_minimum_required(VERSION 3.18.0)

project(
	pam_u2f
	VERSION 1.4.0
	HOMEPAGE_URL https://developers.yubico.com/pam-u2f/
	LANGUAGES C
)

set(PROJECT_BUGREPORT https://github.com/Yubico/pam-u2f/issues)

find_package(PkgConfig REQUIRED)
include(CMakePushCheckState)
include(CheckCCompilerFlag)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CTest)
include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(DEFAULT_PAM_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
if (CMAKE_SYSTEM_NAME STREQUAL Linux)
	string(APPEND DEFAULT_PAM_DIR /security)
elseif (CMAKE_SYSTEM_NAME STREQUAL Darwin)
	string(APPEND DEFAULT_PAM_DIR /pam)
endif()

set(DEFAULT_SCONF_DIR ${CMAKE_INSTALL_FULL_SYSCONFDIR}/security)

option(BUILD_MODULE    "Build pam_u2f.so"                ON)
option(BUILD_MANPAGES  "Build man pages"                 ON)
option(BUILD_PAMU2FCFG "Build pamu2fcfg"                 ON)
option(BUILD_FUZZER    "Build fuzzer"                    OFF)
option(ENABLE_DIST     "Enable dist target"              OFF)
set(SCONF_DIR ${DEFAULT_SCONF_DIR} CACHE PATH "Path to module configuration file")
set(PAM_DIR   ${DEFAULT_PAM_DIR}   CACHE PATH "Where to install the PAM module")

message(STATUS "OPTIONS:")
message(STATUS "  BUILD_MODULE:    ${BUILD_MODULE}")
message(STATUS "  BUILD_MANPAGES:  ${BUILD_MANPAGES}")
message(STATUS "  BUILD_PAMU2FCFG: ${BUILD_PAMU2FCFG}")
message(STATUS "  BUILD_TESTING:   ${BUILD_TESTING}")
message(STATUS "  BUILD_FUZZER:    ${BUILD_FUZZER}")
message(STATUS "  ENABLE_DIST:     ${ENABLE_DIST}")
message(STATUS "  SCONF_DIR:       ${SCONF_DIR}")
message(STATUS "  PAM_DIR:         ${PAM_DIR}")

add_library(common INTERFACE)

target_compile_features(common INTERFACE c_std_11)
target_compile_options(common INTERFACE
	-Wall
	-Wbad-function-cast
	-Wcast-qual
	-Wconversion
	-Wextra
	-Wformat-nonliteral
	-Wformat-security
	-Wformat=2
	-Wmissing-declarations
	-Wmissing-prototypes
	 # Because pam headers are doing sign-conversion, see
	 # PAM_MODUTIL_DEF_PRIVS in pam_modutil.h
	-Wno-sign-conversion
	-Wnull-dereference
	-Wpedantic
	-Wpointer-arith
	-Wshadow
	-Wstrict-prototypes
	-Wwrite-strings

	# Prevent __FILE__ to be expanded with full path
	-ffile-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}/=
)

if (CMAKE_C_COMPILER_ID STREQUAL "Clang" OR
    CMAKE_C_COMPILER_ID STREQUAL "AppleClang")
	target_compile_options(common INTERFACE -Wno-extra-semi)
endif()

cmake_push_check_state(RESET)
	set(CMAKE_REQUIRED_DEFINITIONS
		-D_DARWIN_C_SOURCE=1
		-D_GNU_SOURCE=1
		-D_NETBSD_SOURCE=1
		-D_OPENBSD_SOURCE=1
		-D__STDC_WANT_LIB_EXT1__=1
	)
	check_symbol_exists(explicit_bzero string.h HAVE_EXPLICIT_BZERO)
	check_symbol_exists(memset_s string.h HAVE_MEMSET_S)
	check_symbol_exists(readpassphrase readpassphrase.h HAVE_READPASSPHRASE)
	check_symbol_exists(secure_getenv stdlib.h HAVE_SECURE_GETENV)
	check_symbol_exists(strlcpy string.h HAVE_STRLCPY)
	foreach (v
		HAVE_EXPLICIT_BZERO
		HAVE_MEMSET_S
		HAVE_READPASSPHRASE
		HAVE_SECURE_GETENV
		HAVE_STRLCPY
	)
		if (${v})
			target_compile_definitions(common INTERFACE ${v})
		endif()
	endforeach()
	target_compile_definitions(common INTERFACE ${CMAKE_REQUIRED_DEFINITIONS})
cmake_pop_check_state()

find_package(PAM MODULE REQUIRED)
cmake_push_check_state(RESET)
	set(CMAKE_REQUIRED_LIBRARIES PAM::PAM)
	check_symbol_exists(openpam_borrow_cred security/pam_modules.h HAVE_OPENPAM_BORROW_CRED)
	check_symbol_exists(pam_modutil_drop_priv security/pam_modutil.h HAVE_PAM_MODUTIL_DROP_PRIV)
	foreach (v
		HAVE_OPENPAM_BORROW_CRED
		HAVE_PAM_MODUTIL_DROP_PRIV
	)
		if (${v})
			target_compile_definitions(common INTERFACE ${v})
		endif()
	endforeach()
cmake_pop_check_state()

pkg_check_modules(LibCrypto REQUIRED IMPORTED_TARGET libcrypto)
if (LibCrypto_VERSION VERSION_GREATER_EQUAL 3.0)
	# XXX Silence deprecation warnings for the EC_KEY_* family of functions.
	# This can be removed when we mandate libfido2 >=1.9.0 and switch to the EVP
	# interface.
	target_compile_definitions(PkgConfig::LibCrypto INTERFACE OPENSSL_API_COMPAT=0x10100000L)
endif()

pkg_check_modules(LibFido2 REQUIRED IMPORTED_TARGET libfido2>=1.3.0)

target_compile_definitions(common INTERFACE
	PACKAGE_BUGREPORT="${PROJECT_BUGREPORT}"
	PACKAGE_VERSION="${CMAKE_PROJECT_VERSION}"
	SCONFDIR="${SCONF_DIR}"
	HAVE_UNISTD_H  # assume always available
)

add_library(pam_u2f_base INTERFACE EXCLUDE_FROM_ALL)
target_compile_definitions(pam_u2f_base INTERFACE DEBUG_PAM=1 PAM_DEBUG=1)
target_include_directories(pam_u2f_base INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(pam_u2f_base INTERFACE
	PkgConfig::LibCrypto
	PkgConfig::LibFido2
	PAM::PAM
	common
)

set(PAM_U2F_SOURCES
	pam-u2f.c
	b64.c
	cfg.c
	debug.c
	drop_privs.h
	expand.c
	util.c
	explicit_bzero.c
)
list(TRANSFORM PAM_U2F_SOURCES PREPEND ${CMAKE_CURRENT_SOURCE_DIR}/)

if (BUILD_MODULE)
	add_library(pam_u2f MODULE ${PAM_U2F_SOURCES})
	set_target_properties(pam_u2f PROPERTIES PREFIX "")
	target_link_libraries(pam_u2f PRIVATE pam_u2f_base)

	if(APPLE AND (CMAKE_C_COMPILER_ID STREQUAL "Clang" OR
	    CMAKE_C_COMPILER_ID STREQUAL "AppleClang"))
		target_link_options(pam_u2f PRIVATE
			-Wl,-exported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/export.llvm
		)
	else()
		target_link_options(pam_u2f PRIVATE
			-Wl,--version-script -Wl,${CMAKE_CURRENT_SOURCE_DIR}/export.gnu
		)
	endif()
	install(TARGETS pam_u2f LIBRARY DESTINATION ${PAM_DIR})
endif()

if (BUILD_MANPAGES)
	add_subdirectory(man)
endif()

if (BUILD_PAMU2FCFG)
	add_subdirectory(pamu2fcfg)
endif()

if (BUILD_TESTING)
	enable_testing()
	add_subdirectory(tests)
endif()

if (BUILD_FUZZER)
	add_subdirectory(fuzz)
endif()

if (ENABLE_DIST)
	find_program(GIT git REQUIRED)

	set(DIST_PREFIX  ${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION})
	set(DIST_FORMAT  tar.gz)
	set(DIST_AR_OPTS -9)
	set(DIST_TAG     ${DIST_PREFIX})
	set(DIST_TARBALL ${DIST_PREFIX}.${DIST_FORMAT})

	add_custom_command(
		OUTPUT ${DIST_TARBALL}
		COMMAND
			${GIT}
				-C ${CMAKE_CURRENT_SOURCE_DIR}
				archive
				--prefix=${DIST_PREFIX}/
				--format ${DIST_FORMAT}
				--output ${CMAKE_CURRENT_BINARY_DIR}/${DIST_TARBALL}
				${DIST_AR_OPTS}
				${DIST_TAG}
	)
	add_custom_target(dist DEPENDS ${DIST_TARBALL})
endif()

=== fuzz/CMakeLists.txt ===
# Copyright (C) 2025 Yubico AB - See COPYING

add_library(pam_u2f_fuzz SHARED ${PAM_U2F_SOURCES} wrap.c)
target_link_options(pam_u2f_fuzz PRIVATE
	-Wl,--wrap=asprintf
	-Wl,--wrap=strdup
	-Wl,--wrap=calloc
	-Wl,--wrap=malloc
	-Wl,--wrap=open
	-Wl,--wrap=openat
	-Wl,--wrap=close
	-Wl,--wrap=fdopen
	-Wl,--wrap=fstat
	-Wl,--wrap=read
	-Wl,--wrap=gethostname
	-Wl,--wrap=getline
	-Wl,--wrap=getpwnam_r
	-Wl,--wrap=getpwuid_r
	-Wl,--wrap=geteuid
	-Wl,--wrap=secure_getenv
	-Wl,--wrap=pam_get_user
	-Wl,--wrap=pam_get_item
	-Wl,--wrap=pam_modutil_drop_priv
	-Wl,--wrap=pam_modutil_regain_priv
	-Wl,--wrap=BIO_new
	-Wl,--wrap=BIO_write
	-Wl,--wrap=BIO_read
	-Wl,--wrap=BIO_ctrl
	-Wl,--wrap=BIO_new_mem_buf
	-Wl,--wrap=EC_KEY_new_by_curve_name
	-Wl,--wrap=EC_KEY_get0_group
	-Wl,--wrap=fido_dev_open
	-Wl,--wrap=fido_dev_info_manifest

	-Wl,--version-script,${CMAKE_CURRENT_SOURCE_DIR}/export.gnu
)

target_compile_options(pam_u2f_fuzz PRIVATE -fsanitize=fuzzer-no-link)
target_compile_definitions(pam_u2f_fuzz PRIVATE WITH_FUZZING)
target_link_libraries(pam_u2f_fuzz PUBLIC pam_u2f_base)

function(add_fuzzer NAME)
	add_executable(${NAME} ${ARGN})
	target_compile_options(${NAME} PRIVATE -fsanitize=fuzzer)
	target_link_libraries(${NAME} PRIVATE common pam_u2f_fuzz)
	target_link_options(${NAME} PRIVATE -fsanitize=fuzzer)
endfunction()

add_fuzzer(fuzz_format_parsers fuzz_format_parsers.c)
add_fuzzer(fuzz_auth fuzz_auth.c pack.c)

=== man/CMakeLists.txt ===
#  Copyright (C) 2025 Yubico AB - See COPYING

find_program(A2X a2x REQUIRED)

function(a2x_man MAN_NAME SECTION)
	set(MAN_DIR ${CMAKE_CURRENT_BINARY_DIR}/man${SECTION})
	set(MAN_FILE ${MAN_NAME}.${SECTION})
	set(MAN_TARGET ${MAN_DIR}/${MAN_FILE})
	set(MAN_INPUT ${CMAKE_CURRENT_SOURCE_DIR}/${MAN_NAME}.${SECTION}.txt)

	make_directory(${MAN_DIR})
	add_custom_command(
		OUTPUT ${MAN_TARGET}
		COMMAND
			${A2X}
				--format=manpage
				--no-xmllint
				--attribute revdate="Version ${CMAKE_PROJECT_VERSION}"
				--attribute sconfdir="${SCONF_DIR}"
				--destination-dir ${MAN_DIR}
				${MAN_INPUT}
	)
	add_custom_target(man_${MAN_NAME}_${SECTION} ALL DEPENDS ${MAN_TARGET})
	install(FILES ${MAN_TARGET}
		DESTINATION ${CMAKE_INSTALL_MANDIR}/man${SECTION})

endfunction()

a2x_man(pamu2fcfg 1)
a2x_man(pam_u2f 8)

=== pamu2fcfg/CMakeLists.txt ===
# Copyright (C) 2025 Yubico AB - See COPYING

add_executable(pamu2fcfg
	pamu2fcfg.c
	strlcpy.c
	readpassphrase.c
	../util.c
	../b64.c
	../explicit_bzero.c
)

target_link_libraries(pamu2fcfg PRIVATE
	common
	PkgConfig::LibCrypto
	PkgConfig::LibFido2
	# TODO: Remove implicit dependency on PAM
	PAM::PAM
)

target_include_directories(pamu2fcfg PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/..)
install(TARGETS pamu2fcfg)

=== tests/CMakeLists.txt ===
# Copyright (C) 2025 Yubico AB - See COPYING

set(USERNAME $ENV{USER})
if (NOT DEFINED USERNAME)
	execute_process(
		COMMAND whoami
		OUTPUT_VARIABLE USERNAME
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)
endif()

function(expand_username FILE_NAME)
	configure_file(${FILE_NAME}.in ${FILE_NAME})
endfunction()

expand_username(credentials/new_double_-N.cred)
expand_username(credentials/new_double_-P-N.cred)
expand_username(credentials/new_double_-P.cred)
expand_username(credentials/new_double_-P-V-N.cred)
expand_username(credentials/new_double_-P-V.cred)
expand_username(credentials/new_double_-r-N.cred)
expand_username(credentials/new_double_-r-P-N.cred)
expand_username(credentials/new_double_-r-P.cred)
expand_username(credentials/new_double_-r-P-V-N.cred)
expand_username(credentials/new_double_-r-P-V.cred)
expand_username(credentials/new_double_-r.cred)
expand_username(credentials/new_double_-r-V-N.cred)
expand_username(credentials/new_double_-r-V.cred)
expand_username(credentials/new_double_.cred)
expand_username(credentials/new_double_-V-N.cred)
expand_username(credentials/new_double_-V.cred)
expand_username(credentials/new_mixed_12.cred)
expand_username(credentials/new_mixed_1-P2.cred)
expand_username(credentials/new_mixed_-P12.cred)
expand_username(credentials/new_mixed_-P1-P2.cred)
expand_username(credentials/new_-N.cred)
expand_username(credentials/new_-P-N.cred)
expand_username(credentials/new_-P.cred)
expand_username(credentials/new_-P-V-N.cred)
expand_username(credentials/new_-P-V.cred)
expand_username(credentials/new_-r-N.cred)
expand_username(credentials/new_-r-P-N.cred)
expand_username(credentials/new_-r-P.cred)
expand_username(credentials/new_-r-P-V-N.cred)
expand_username(credentials/new_-r-P-V.cred)
expand_username(credentials/new_-r.cred)
expand_username(credentials/new_-r-V-N.cred)
expand_username(credentials/new_-r-V.cred)
expand_username(credentials/new_.cred)
expand_username(credentials/new_-V-N.cred)
expand_username(credentials/new_-V.cred)
expand_username(credentials/old_credential.cred)
expand_username(credentials/ssh_credential.cred)
expand_username(credentials/new_limited_count.cred)
expand_username(credentials/empty.cred)

if (BUILD_MODULE)
	add_executable(dlsym_check dlsym_check.c)
	target_link_libraries(dlsym_check PRIVATE
		common
		${CMAKE_DL_LIBS}
	)
	add_test(NAME dlsym_check COMMAND dlsym_check)

	add_dependencies(dlsym_check pam_u2f)
	set_tests_properties(dlsym_check PROPERTIES
		ENVIRONMENT PAM_U2F_MODULE=$<TARGET_FILE:pam_u2f>
	)
endif()

add_library(pam_u2f_testing STATIC EXCLUDE_FROM_ALL ${PAM_U2F_SOURCES})
target_compile_definitions(pam_u2f_testing PRIVATE PAM_U2F_TESTING)
target_link_libraries(pam_u2f_testing PUBLIC pam_u2f_base)

add_executable(get_devices get_devices.c)
target_link_libraries(get_devices PRIVATE
	common
	pam_u2f_testing
)
add_test(NAME get_devices COMMAND get_devices)

add_executable(expand expand.c)
target_link_libraries(expand PRIVATE
	common
	pam_u2f_testing
)
add_test(NAME expand COMMAND expand)

add_executable(cfg cfg.c)
target_link_libraries(cfg PRIVATE
	common
	pam_u2f_testing
)
add_test(NAME cfg COMMAND cfg)

## pam-u2f 1.0.1

=== debian/changelog ===
pam-u2f (1.0.1-1) unstable; urgency=medium

  [ Alessio Di Mauro ]
  * New upstream release.

  [ Simon Josefsson ]
  * Update README.source.
  * Update upstream-signing-key.pgp.
  * Add gbp.conf.

 -- Alessio Di Mauro <alessio@yubico.com>  Thu, 18 Jun 2015 10:35:12 +0200

pam-u2f (1.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Alessio Di Mauro <alessio@yubico.com>  Wed, 17 Jun 2015 14:19:14 +0200

pam-u2f (0.0.1-1) unstable; urgency=low

  * Initial release. (Closes: #776091)

 -- Alessio Di Mauro <alessio@yubico.com>  Mon, 26 Jan 2015 13:57:25 +0100

=== debian/control ===
Source: pam-u2f
Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Di Mauro <alessio@yubico.com>, Simon Josefsson <simon@josefsson.org>
Section: admin
Priority: optional
Build-Depends: debhelper (>= 9),
	autotools-dev,
	dh-autoreconf,
	pkg-config,
	libpam0g-dev,
        libu2f-host-dev,
        libu2f-server-dev
Standards-Version: 3.9.6
Homepage: https://developers.yubico.com/pam-u2f/
Vcs-Browser: https://github.com/Yubico/pam-u2f-dpkg
Vcs-Git: git://github.com/Yubico/pam-u2f-dpkg.git

Package: libpam-u2f
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: universal 2nd factor (U2F) PAM module
 Universal 2nd Factor (U2F) is an authentication mechanism that strengthen
 other authentications, and through this PAM module it can be used to
 require a U2F device in order to authenticate.
 .
 This package contains the PAM module, which performs the U2F
 Authentication step.  Before this, you need to perform the U2F Registration
 step which can be completed using the pamu2fcfg package.

Package: pamu2fcfg
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: universal 2nd factor (U2F) PAM module command-line helper tool
 Universal 2nd Factor (U2F) is an authentication mechanism that strengthen
 other authentications, and through this PAM module it can be used to
 require a U2F device in order to authenticate.
 .
 This package contains the command-line tool pamu2fcfg which is used
 to generate the information needed by libpam-u2f to perform an U2F
 authentication.

## pam-u2f 1.0.3

=== debian/changelog ===
pam-u2f (1.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Alessio Di Mauro <alessio@yubico.com>  Mon, 02 Nov 2015 15:47:25 +0100

pam-u2f (1.0.2-1) unstable; urgency=medium

  [ Alessio Di Mauro ]
  * New upstream version

  [ Simon Josefsson ]
  * Update upstream-signing-key.pgp.

 -- Alessio Di Mauro <alessio@yubico.com>  Tue, 06 Oct 2015 14:34:08 +0200

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
 Package: libpam-u2f
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: pamu2fcfg
 Description: universal 2nd factor (U2F) PAM module
  Universal 2nd Factor (U2F) is an authentication mechanism that strengthen
  other authentications, and through this PAM module it can be used to

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autoreconf --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-silent-rules \
		--with-pam-dir=$(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/security

override_dh_install:
	rm debian/tmp/lib/$(DEB_HOST_MULTIARCH)/security/pam_u2f.la
	dh_install --fail-missing

## pam-u2f 1.0.4

=== debian/changelog ===
pam-u2f (1.0.4-2) unstable; urgency=medium

  * debian/control: Add myself as uploader
  * debian/control: Move the packaging repo to Alioth

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Fri, 23 Sep 2016 20:38:06 +0200

pam-u2f (1.0.4-1) unstable; urgency=medium

  * Acknowledge NMU, thanks Nicolas.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 10 Aug 2016 16:08:42 +0200

pam-u2f (1.0.4-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix the generated binaries on Debian/kFreeBSD
  * Drop spurious dependency on autotools-dev

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Tue, 02 Aug 2016 15:48:58 +0200

pam-u2f (1.0.4-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Set Breaks and Replaces for the moved manpage.

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Thu, 14 Jul 2016 21:53:52 +0200

pam-u2f (1.0.4-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream version.
    Fixes possible permission escalation when using XDG_CONFIG_HOME.
  * Use HTTPS for Vcs-Git.
  * Use build-time hardening.
  * Bump Standards-Version to 3.9.8.
    No change required.
  * Put the pam_u2f(8) manpage in the libpam_u2f package.

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Wed, 06 Jul 2016 13:25:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,25 @@
 Source: pam-u2f
 Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
-Uploaders: Alessio Di Mauro <alessio@yubico.com>, Simon Josefsson <simon@josefsson.org>
+Uploaders: Alessio Di Mauro <alessio@yubico.com>,
+	   Simon Josefsson <simon@josefsson.org>,
+	   Nicolas Braud-Santoni <nicolas@braud-santoni.eu>
 Section: admin
 Priority: optional
 Build-Depends: debhelper (>= 9),
-	autotools-dev,
 	dh-autoreconf,
 	pkg-config,
 	libpam0g-dev,
         libu2f-host-dev,
         libu2f-server-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://developers.yubico.com/pam-u2f/
-Vcs-Browser: https://github.com/Yubico/pam-u2f-dpkg
-Vcs-Git: git://github.com/Yubico/pam-u2f-dpkg.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-auth/pam-u2f.git/
+Vcs-Git: https://anonscm.debian.org/git/pkg-auth/pam-u2f.git
 
 Package: libpam-u2f
 Architecture: any
+Breaks: pamu2fcfg (<< 1.0.4-0.2)
+Replaces: pamu2fcfg (<< 1.0.4-0.2)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: pamu2fcfg
 Description: universal 2nd factor (U2F) PAM module
@@ -30,6 +33,7 @@
 
 Package: pamu2fcfg
 Architecture: any
+Breaks: libpam-u2f (<< 1.0.4-0.2)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: universal 2nd factor (U2F) PAM module command-line helper tool
  Universal 2nd Factor (U2F) is an authentication mechanism that strengthen

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --with autoreconf --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-silent-rules \
		--with-pam-dir=$(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/security

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ https://developers.yubico.com/pam-u2f/Releases/ pam_u2f-(\d[\d.]*)\.tar\.gz

## pam-u2f 1.0.7

=== debian/changelog ===
pam-u2f (1.0.7-1+deb10u1) buster; urgency=high

  * Backport multiple security fixes
     + Fix insecure debug file handling CVE-2019-12209. (Closes: #930021)
     + Fix debug file descriptor leak CVE-2019-12210. (Closes: #930023)
     + Fix a non-critical buffer out-of-bounds access. (Closes: #930047)

  * Backport a reliability fix
    pam-u2f could previously segfault following a failure to allocate a buffer.

 -- Nicolas Braud-Santoni <nicoo@debian.org>  Tue, 13 Aug 2019 01:06:31 +0200

pam-u2f (1.0.7-1) unstable; urgency=high

  * New upstream version 1.0.7 (2018-05-15)
    Closes: #898519
  * Update & complete debian/copyright
  * Move the packaging repository to salsa.d.o
  * Use the tracker.debian.org email address for the maintainers.
  * Switch to debhelper 11

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Tue, 29 May 2018 14:33:06 +0200

pam-u2f (1.0.6-1) unstable; urgency=medium

  * New upstream version (2018-04-18)
    - Remove upstreamed patch

  * Bump Standards-Version to 4.1.4
    - debian/copyright: Use HTTPS Format URI

  * Update upstream's keyring
    - Move it to debian/upstream
    - Include a script debian/upstream/signing-key.sh that generates it

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Mon, 30 Apr 2018 13:35:48 +0200

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --parallel --with autoreconf --builddirectory=build
+	dh $@ --builddirectory=build
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

## pam-u2f 1.0.8

=== debian/changelog ===
pam-u2f (1.0.8-1) unstable; urgency=high (security)

  [ Nicolas Braud-Santoni ]
  * New upstream version 1.0.8 (2019-06-04)
    + Fix insecure debug file handling CVE-2019-12209. (Closes: #930021)
    + Fix debug file descriptor leak CVE-2019-12210. (Closes: #930023)
    + Fix a non-critical buffer out-of-bounds access.

  * Comply with Debian policy v4.4.0
    + debian/control: Set Rules-Requires-Root to no
    + debian/rules:   Install upstream's changelog

  * debian/control: Update my email address
  * debian/gbp.conf: Move the packaging ranch to debian/sid

  [ Simon Josefsson ]
  * Drop myself from Uploader's.

 -- Nicolas Braud-Santoni <nicoo@debian.org>  Sat, 20 Jul 2019 13:01:18 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: pam-u2f
-Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
-Uploaders: Alessio Di Mauro <alessio@yubico.com>,
-	   Simon Josefsson <simon@josefsson.org>,
-	   Nicolas Braud-Santoni <nicolas@braud-santoni.eu>
+Maintainer: Debian Authentication Maintainers <team+auth@tracker.debian.org>
+Uploaders:
+	Alessio Di Mauro <alessio@yubico.com>,
+	Nicolas Braud-Santoni <nicoo@debian.org>
 Section: admin
 Priority: optional
-Build-Depends: debhelper (>= 9),
-	dh-autoreconf,
+Build-Depends:
+	debhelper (>= 11),
 	pkg-config,
 	libpam0g-dev,
-        libu2f-host-dev,
-        libu2f-server-dev
-Standards-Version: 3.9.8
+	libu2f-host-dev,
+	libu2f-server-dev
+Standards-Version: 4.4.0
 Homepage: https://developers.yubico.com/pam-u2f/
-Vcs-Browser: https://anonscm.debian.org/git/pkg-auth/pam-u2f.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-auth/pam-u2f.git
+Vcs-Browser: https://salsa.debian.org/auth-team/pam-u2f
+Vcs-Git: https://salsa.debian.org/auth-team/pam-u2f.git
+Rules-Requires-Root: no
 
 Package: libpam-u2f
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -9,3 +9,6 @@
 	dh_auto_configure -- \
 		--disable-silent-rules \
 		--with-pam-dir=$(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/security
+
+override_dh_installchangelogs:
+	dh_installchangelogs NEWS

## pam-u2f 1.1.0

=== debian/changelog ===
pam-u2f (1.1.0-1.1+deb12u1build0.22.04.1) jammy-security; urgency=medium

  * fake sync from Debian

 -- John Breton <john.breton@canonical.com>  Wed, 27 Aug 2025 09:44:48 -0400

pam-u2f (1.1.0-1.1+deb12u1) bookworm-security; urgency=high

  * Start to backport the fixes for CVE-2025-23013 to debian stable
    (CVE-2025-23013)
  * Refactored the do_not_return_PAM_IGNORE patch for bookworm
    (CVE-2025-23013)

 -- Patrick Winnertz <winnie@debian.org>  Thu, 23 Jan 2025 17:04:59 +0100

pam-u2f (1.1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Handle converse() returning NULL (CVE-2021-31924) (Closes: #987545)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 05 Jun 2021 15:04:24 +0200

pam-u2f (1.1.0-1) unstable; urgency=low

  * New upstream version 1.1.0 (2020-09-17)
    + Add support for FIDO2
      Switch from libu2f-host+libu2f-server to libfido2
    + Add support for User Verification
    + Add support for PIN Verification
    + Add support for Resident Credentials
    + Add support for SSH credential format

  * Update nicoo's name & address
  * libpam-u2f: Override Lintian warning about the pam_u2f(8) manpage.
    See Lintian bug #973604
  * d/copyright:
    + Set Upstream-Contact to Yubico's OSS maintainers role
    + Update package authorship metadata

  * Switch to debhelper 12.
    Replace the deprecated debian/compat file with a Build-Depends on
    debhelper-compat
  * d/upstream: Update signing keyring
  * d/control: Declare compliance with policy v4.5.0.
    No change required
  * Drop obsolete README.source.
    The package should explain how to explain cowbuilder, or refer to the
    packaging repo by an URL that has been obsolete for years.
  * d/gbp.conf: Sign tags.
    Unsure why I disabled it.
  * d/rules: No need to pass --builddirectory to dh
  * d/watch: Update to uscan v4, tidy up the syntax

 -- nicoo <nicoo@debian.org>  Mon, 02 Nov 2020 13:49:23 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,16 @@
 Maintainer: Debian Authentication Maintainers <team+auth@tracker.debian.org>
 Uploaders:
 	Alessio Di Mauro <alessio@yubico.com>,
-	Nicolas Braud-Santoni <nicoo@debian.org>
+	nicoo <nicoo@debian.org>
 Section: admin
 Priority: optional
 Build-Depends:
-	debhelper (>= 11),
+	debhelper-compat (= 12),
 	pkg-config,
+  libfido2-dev,
 	libpam0g-dev,
-	libu2f-host-dev,
-	libu2f-server-dev
-Standards-Version: 4.4.0
+  libssl-dev
+Standards-Version: 4.5.0
 Homepage: https://developers.yubico.com/pam-u2f/
 Vcs-Browser: https://salsa.debian.org/auth-team/pam-u2f
 Vcs-Git: https://salsa.debian.org/auth-team/pam-u2f.git

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --builddirectory=build
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

## pam-u2f 1.3.0

=== debian/changelog ===
pam-u2f (1.3.0-1) unstable; urgency=medium

  * Update the keys according to the yubico website
    and delete one from the keyring.
  * Modify gbp.conf
    + Remove autosigning of upstream, I can't check that
      tag (and the content) before signing.
    + Extend the included gbp so that everybody
      uses gz in this case.
  * Accknowledge NMU from Salvatore Bonaccorso <carnil@debian.org>
    to close CVE-2021-31924 (Closes: #987545) - see release 1.1.1
  * New upstream version 1.3.0 (Closes: #1022073)
    + Add sanity checking of UV options to pamu2fcfg.
    + Add support for username expansion in the authfile path.
    + Improvements to the documentation.
    + 1.2.1:
    	+ Fixed an issue where native credentials could be truncated,
          resulting in failure to authenticate or successful
          authentication with missing options.
    	+ Stricter parsing of sshformat credentials.
    	+ pamu2fcfg now allows a combination of the
          --username and --nouser options.
    	+ Improved documentation on FIDO2 options.
    + 1.2.0:
        + Added support for EdDSA keys.
        + Added support for SSH ed25519-sk keys.
        + Added authenticator filtering based on user verification options.
        + Fixed an issue with privilege restoration on MacOS.
        + Fixed an issue where credentials created with pamu2fcfg
          1.0.8 or earlier were not handled correctly if their origin
          and appid differed.
        + Miscellaneous improvements to the documentation.
        + Miscellaneous minor bug fixes found by fuzzing.
    + 1.1.1:
    	+ Fix an issue where PIN authentication could be
          bypassed (CVE-2021-31924).
    	+ Fix an issue with nodetect and non-resident credentials.
    	+ Fix build issues with musl libc.
    	+ Add support for self-attestation in pamu2fcfg.
    	+ Fix minor bugs found by fuzzing.
  * Modify lintian override for new syntax
  * Update copyright and add myself
  * Switch to compat level 13
  * Raise the standards-version to 4.6.2 (no changes needed)
  * Switched from pkg-config to pkgconf.
  * Removed Alessio Di Mauro and Nicoo as uploaders, according
    to process described here: https://wiki.debian.org/PackageSalvaging
  * Install package into /usr according to the /usr-merge. (Closes: #1061859)
    Thanks to Michael Biebl <biebl@debian.org> for the patch.

 -- Patrick Winnertz <winnie@debian.org>  Sat, 06 Apr 2024 14:33:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: pam-u2f
 Maintainer: Debian Authentication Maintainers <team+auth@tracker.debian.org>
-Uploaders:
-	Alessio Di Mauro <alessio@yubico.com>,
-	nicoo <nicoo@debian.org>
+Uploaders: Patrick Winnertz <winnie@debian.org>
 Section: admin
 Priority: optional
 Build-Depends:
-	debhelper-compat (= 12),
-	pkg-config,
+	debhelper-compat (= 13),
+	pkgconf,
   libfido2-dev,
 	libpam0g-dev,
   libssl-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Homepage: https://developers.yubico.com/pam-u2f/
 Vcs-Browser: https://salsa.debian.org/auth-team/pam-u2f
 Vcs-Git: https://salsa.debian.org/auth-team/pam-u2f.git

## pam-u2f 1.3.1

=== debian/changelog ===
pam-u2f (1.3.1-1) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Set upstream metadata fields.

  [ Simon Josefsson ]
  * New upstream version 1.3.1
  * Bump d/* copyright years, adding myself.
  * Use Standards-Version 4.7.0.
  * Run wrap-and-sort -satbk.
  * Add d/salsa-ci.yml.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 14 Jan 2025 18:20:07 +0100

## pam-u2f 1.3.2

=== debian/changelog ===
pam-u2f (1.3.2-1) unstable; urgency=medium

  * New upstream version 1.3.2

 -- Patrick Winnertz <winnie@debian.org>  Sat, 18 Jan 2025 23:32:12 +0100

=== debian/control ===
Source: pam-u2f
Maintainer: Debian Authentication Maintainers <team+auth@tracker.debian.org>
Uploaders:
 Patrick Winnertz <winnie@debian.org>,
Section: admin
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 libfido2-dev,
 libpam0g-dev,
 libssl-dev,
 pkgconf,
Standards-Version: 4.7.0
Homepage: https://developers.yubico.com/pam-u2f/
Vcs-Browser: https://salsa.debian.org/auth-team/pam-u2f
Vcs-Git: https://salsa.debian.org/auth-team/pam-u2f.git
Rules-Requires-Root: no

Package: libpam-u2f
Architecture: any
Breaks:
 pamu2fcfg (<< 1.0.4-0.2),
Replaces:
 pamu2fcfg (<< 1.0.4-0.2),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 pamu2fcfg,
Description: universal 2nd factor (U2F) PAM module
 Universal 2nd Factor (U2F) is an authentication mechanism that strengthen
 other authentications, and through this PAM module it can be used to
 require a U2F device in order to authenticate.
 .
 This package contains the PAM module, which performs the U2F
 Authentication step.  Before this, you need to perform the U2F Registration
 step which can be completed using the pamu2fcfg package.

Package: pamu2fcfg
Architecture: any
Breaks:
 libpam-u2f (<< 1.0.4-0.2),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: universal 2nd factor (U2F) PAM module command-line helper tool
 Universal 2nd Factor (U2F) is an authentication mechanism that strengthen
 other authentications, and through this PAM module it can be used to
 require a U2F device in order to authenticate.
 .
 This package contains the command-line tool pamu2fcfg which is used
 to generate the information needed by libpam-u2f to perform an U2F
 authentication.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-silent-rules \
		--with-pam-dir=/usr/lib/$(DEB_HOST_MULTIARCH)/security

override_dh_installchangelogs:
	dh_installchangelogs NEWS

## pam-u2f 1.4.0

=== debian/changelog ===
pam-u2f (1.4.0-3) unstable; urgency=medium

  * Team upload.
  * Run wrap-and-sort -sabtk.
  * Fix Vcs-* URLs.
  * Mark libpam-u2f as Multi-Arch: same.

 -- Simon Josefsson <simon@josefsson.org>  Fri, 29 Aug 2025 20:43:34 +0200

pam-u2f (1.4.0-2) unstable; urgency=medium

  * Move package to pkg-security Team
  * Removed spelling error in previous changelog entry

 -- Patrick Winnertz <winnie@debian.org>  Thu, 28 Aug 2025 22:02:15 +0200

pam-u2f (1.4.0-1) unstable; urgency=medium

  * Added Signing Key from Giovanni Simoni
    F475 9282 2522 9F58 4606 40EA D917 77C1 7553 3EE5
  * New upstream version 1.4.0
  * Updated standards version - no changes needed

 -- Patrick Winnertz <winnie@debian.org>  Thu, 24 Apr 2025 21:20:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: pam-u2f
-Maintainer: Debian Authentication Maintainers <team+auth@tracker.debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders:
  Patrick Winnertz <winnie@debian.org>,
 Section: admin
@@ -10,14 +10,15 @@
  libpam0g-dev,
  libssl-dev,
  pkgconf,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://developers.yubico.com/pam-u2f/
-Vcs-Browser: https://salsa.debian.org/auth-team/pam-u2f
-Vcs-Git: https://salsa.debian.org/auth-team/pam-u2f.git
+Vcs-Browser: https://salsa.debian.org/debian/pam-u2f
+Vcs-Git: https://salsa.debian.org/debian/pam-u2f.git
 Rules-Requires-Root: no
 
 Package: libpam-u2f
 Architecture: any
+Multi-Arch: same
 Breaks:
  pamu2fcfg (<< 1.0.4-0.2),
 Replaces:
